C
C*** Example Driver 1
C
C     PROGRAM EXAMPL(UGOUT,TAPE3=UGOUT)
      INTEGER IOUT
      PARAMETER (IOUT = 6)
      COMMON /ENDPT/ XLEFT
      COMMON /GEAR0/ DTUSED,NQ,NSTEPS,NF,NJ
      DIMENSION U(2,31),XBKPT(31),SCTCH(10),WORK(5000),IWORK(500)
C
C INITIALIZE PARAMETERS AND PDECOL CALLING ARGUMENTS
C
      NPDE = 2
      NINT = 30
      NPTS = NINT + 1
      KORD = 4
      NCC = 2
      T0 = 0.0
      TOUT = 1.E-3
      DT = 1.E-7
      EPS = 1.E-4
      MF = 21
      INDEX = 1
      IWORK(1) = 5000
      IWORK(2) = 500
      DX = 1. / FLOAT(NPTS-1)
      DO 10 I=1,NPTS
        XBKPT(I) = FLOAT(I-1) * DX
   10 CONTINUE
      XLEFT = XBKPT(1)
C
C CALL THE PACKAGE TO INTEGRATE TO TIME T = TOUT
C
   20 CALL PDECOL(T0,TOUT,DT,XBKPT,EPS,NINT,KORD,NCC,NPDE,MF,INDEX,
     *            WORK,IWORK)
C
C CHECK FOR EXECUTION ERRORS
C
      IF ( INDEX .NE. 0 )  GO TO 70
C
C OUTPUT PERFORMANCE DATA AND COMPUTED SOLUTION VALUES
C
      WRITE(IOUT,30)  TOUT,DTUSED,NSTEPS
   30 FORMAT(//10X,3HT= ,E10.3,7H   DT= ,E10.3,15H   TOTAL STEPS=,I5)
      CALL VALUES(XBKPT,U,SCTCH,NPDE,NPTS,NPTS,0,WORK)
      DO 60 K=1,NPDE
        WRITE(IOUT,40) K
   40   FORMAT(/10X,13HPDE COMPONENT,I2/)
        WRITE(IOUT,50) (U(K,I),I=1,NPTS)
   50   FORMAT(10X,5E12.4)
   60 CONTINUE
C
C SET NEW OUTPUT TIME AND CONTINUE THE INTEGRATION IF TOUT .LT. 11.
C OTHERWISE, TERMINATE THE PROBLEM
C
      TOUT = TOUT * 10.
      IF ( TOUT .LT. 11. )  GO TO 20
   70 WRITE(IOUT,80) INDEX
   80 FORMAT(10X,7HINDEX= ,I3)
      STOP
      END
      SUBROUTINE F(T,X,U,UX,UXX,FVAL,NPDE)
      DIMENSION U(NPDE), UX(NPDE), UXX(NPDE), FVAL(NPDE)
        FVAL(1) = U(2)*U(2)*UXX(1) - U(1)*U(2) - U(1)**2 + 10.
     *          + 2.*U(2)*UX(2)*UX(1)
        FVAL(2) = U(1)*U(1)*UXX(2) + U(1)*U(2) - U(2)**2
     *          + UXX(1) + 2.*U(1)*UX(1)*UX(2)
      RETURN
      END
      SUBROUTINE BNDRY(T,X,U,UX,DBDU,DBDUX,DZDT,NPDE)
      DIMENSION U(NPDE), UX(NPDE), DZDT(NPDE)
      DIMENSION DBDU(NPDE,NPDE), DBDUX(NPDE,NPDE)
      COMMON /ENDPT/ XLEFT
      IF( X .NE. XLEFT ) GO TO 10
        DBDU(1,1) = 1.
        DBDU(1,2) = 0.
        DBDU(2,1) = 0.
        DBDU(2,2) = 1.
        DBDUX(1,1) = 0.
        DBDUX(1,2) = 0.
        DBDUX(2,1) = 0.
        DBDUX(2,2) = 0.
        DZDT(1) = 0.
        DZDT(2) = 0.
      RETURN
   10   DBDU(1,1) = U(2) * COS( U(1) * U(2) )
        DBDU(1,2) = U(1) * COS( U(1) * U(2) )
        DBDU(2,1) = U(2) * SIN( U(1) * U(2) )
        DBDU(2,2) = U(1) * SIN( U(1) * U(2) )
        DBDUX(1,1) = 1.
        DBDUX(1,2) = 0.
        DBDUX(2,1) = 0.
        DBDUX(2,2) = 1.
        DZDT(1) = 0.
        DZDT(2) = 0.
      RETURN
      END
      SUBROUTINE UINIT(X,U,NPDE)
      DIMENSION U(NPDE)
C
C SET INITIAL CONDITIONS.  NOTE THAT  PI = 4.*ATAN(1.)
C
        U(1) = .5 * ( X + 1. )
        U(2) = 4.*ATAN(1.)
      RETURN
      END
      SUBROUTINE DERIVF(T,X,U,UX,UXX,DFDU,DFDUX,DFDUXX,NPDE)
      DIMENSION U(NPDE), UX(NPDE), UXX(NPDE)
      DIMENSION DFDU(NPDE,NPDE), DFDUX(NPDE,NPDE), DFDUXX(NPDE,NPDE)
        DFDU(1,1) = -U(2) - 2.*U(1)
        DFDU(1,2) = 2.*U(2)*UXX(1) - U(1) + 2.*UX(2)*UX(1)
        DFDU(2,1) = 2.*U(1)*UXX(2) + U(2) + 2.*UX(1)*UX(2)
        DFDU(2,2) = U(1) - 2.*U(2)
C
        DFDUX(1,1) = 2.*U(2)*UX(2)
        DFDUX(1,2) = 2.*U(2)*UX(1)
        DFDUX(2,1) = 2.*U(1)*UX(2)
        DFDUX(2,2) = 2.*U(1)*UX(1)
C
        DFDUXX(1,1) = U(2)*U(2)
        DFDUXX(1,2) = 0.
        DFDUXX(2,1) = 1.
        DFDUXX(2,2) = U(1)*U(1)
      RETURN
      END
